From 152ec35ae6faf9258b5db68027ebdd21bafa0d34 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Hugo=20Beauz=C3=A9e-Luyssen?= <beauze.h@gmail.com>
Date: Mon, 23 Jan 2012 16:45:28 +0100
Subject: [PATCH 3/6] hls: Fixing some locks.

---
 modules/stream_filter/httplive.c |    8 ++++----
 1 files changed, 4 insertions(+), 4 deletions(-)

diff --git a/modules/stream_filter/httplive.c b/modules/stream_filter/httplive.c
index 150c200..428d4ea 100644
--- a/modules/stream_filter/httplive.c
+++ b/modules/stream_filter/httplive.c
@@ -1360,11 +1360,11 @@ static int hls_UpdatePlaylist(stream_t *s, hls_stream_t *hls_new, hls_stream_t *
         segment_t *segment = segment_Find(*hls, p->sequence);
         if (segment)
         {
+            vlc_mutex_lock(&segment->lock);
+
             assert(p->url.psz_path);
             assert(segment->url.psz_path);
 
-            vlc_mutex_lock(&segment->lock);
-
             /* they should be the same */
             if ((p->sequence != segment->sequence) ||
                 (p->duration != segment->duration) ||
@@ -1382,6 +1382,7 @@ static int hls_UpdatePlaylist(stream_t *s, hls_stream_t *hls_new, hls_stream_t *
                 {
                     msg_Err(s, "Failed updating segment %d - skipping it",  p->sequence);
                     segment_Free(p);
+                    vlc_mutex_unlock(&segment->lock);
                     continue;
                 }
                 segment->sequence = p->sequence;
@@ -1396,11 +1397,10 @@ static int hls_UpdatePlaylist(stream_t *s, hls_stream_t *hls_new, hls_stream_t *
                 }
                 free(segment->psz_key_path);
                 segment->psz_key_path = p->psz_key_path ? strdup( p->psz_key_path ) : NULL;
+                vlc_mutex_unlock(&segment->lock);
                 segment_Free(p);
                 free(psz_url);
             }
-
-            vlc_mutex_unlock(&segment->lock);
         }
         else
         {
-- 
1.7.8.4

